# Help

## Running the tests

To run the tests, run the command `busted` from within the exercise directory.

Refer to the [Installing Lua locally][install] documentation to get Lua and busted installed correctly.

[install]: https://exercism.org/docs/tracks/lua/installation

## Submitting your solution

You can submit your solution using the `exercism submit hello-world.lua` command.
This command will upload your solution to the Exercism website and print the solution page's URL.

It's possible to submit an incomplete solution which allows you to:

- See how others have completed the exercise
- Request help from a mentor

## Need to get help?

If you'd like help solving the exercise, check the following pages:

- The [Lua track's documentation](https://exercism.org/docs/tracks/lua)
- The [Lua track's programming category on the forum](https://forum.exercism.org/c/programming/lua)
- [Exercism's programming category on the forum](https://forum.exercism.org/c/programming/5)
- The [Frequently Asked Questions](https://exercism.org/docs/using/faqs)

Should those resources not suffice, you could submit your (incomplete) solution to request mentoring.

There are many great free online resources for Lua including:

1. [lua.org][8]
2. A highly recommended detailed and authoritative introduction to all aspects of Lua programming by Lua's chief architect: [Programming in Lua, by Roberto Ierusalimschy][6]. Note that the first edition (covering Lua 5.0) is [freely available online][9].
3. For an official definition of the Lua language, consult the [Lua 5.4 Reference Manual][7], by R. Ierusalimschy, L. H. de Figueiredo, W. Celes.
4. [Lua Style Guide][4]
5. [Learn Lua in 15 minutes][5]
6. Some options for linting
    - [Lua Lint][10]
    - [Lua Inspect][11]
    - [luacheck][12]
    - [Detecting Undefined Variables][13]

[4]: https://github.com/Olivine-Labs/lua-style-guide
[5]: http://tylerneylon.com/a/learn-lua/
[6]: http://www.lua.org/pil/
[7]: http://www.lua.org/manual/5.4/
[8]: http://www.lua.org
[9]: http://www.lua.org/pil/contents.html
[10]: http://lua-users.org/wiki/LuaLint
[11]: http://lua-users.org/wiki/LuaInspect
[12]: https://github.com/luarocks/luacheck
[13]: http://lua-users.org/wiki/DetectingUndefinedVariables